define( function()
{
	"use strict";
	
	function C_HtmlDatalist()
	{
	};
	
	C_HtmlDatalist.prototype.draw = function( oControlHost )
	{
		var oParameter = oControlHost.getParameter( "pl" );
		var sParameterValue = ( oParameter && ( oParameter.values.length > 0 ) ) ? oParameter.values[0].use : "";
		var sHtml = '<input list="dataListDemo" style="font-size: 12pt">' + '<datalist id="dataListDemo">';
		var iRowCount = this.m_oDataStore.rowCount;
		
		for ( var iRow = 0; iRow < iRowCount; iRow++ )
		{
			var sValue = this.m_oDataStore.getCellValue( iRow, 0 );
			var bSelected = sParameterValue && ( sValue == sParameterValue );
			sHtml += '<option value="' + sValue + '"' + ( bSelected ? ' selected="true"' : '' ) + '>';
		}
		sHtml += '</datalist>';
		
		var el = oControlHost.container;
		el.innerHTML = sHtml;
		this.m_sel = el.querySelector( "*" );
		
		if ( sParameterValue )
		{
			this.m_sel.value = sParameterValue;
		}
		
		this.f_onChange( oControlHost );
		this.m_sel.onchange = this.f_onChange.bind( this, oControlHost, true );
	};
	
	C_HtmlDatalist.prototype.f_onChange = function( oControlHost, bAutoSubmit )
	{
		oControlHost.valueChanged();
		if ( bAutoSubmit )
		{
			oControlHost.next();
		}
	};
	
	C_HtmlDatalist.prototype.setData = function( oControlHost, oDataStore )
	{
		this.m_oDataStore = oDataStore;
	};
	
	C_HtmlDatalist.prototype.getParameters = function()
	{
		if ( !this.m_sel.value && this.m_sel.value != "" )
		{
			return null;
		}
		var sValue = this.m_sel.value || undefined;
		return [{
			"parameter": "pl",
			"values": [{ "use" : sValue }]
		}];
	};
	
	C_HtmlDatalist.prototype.isInValidState = function()
	{
		return ( this.m_sel.value );
	};
	
	return C_HtmlDatalist;
});
